package de.ivu.elect.presentation.hilfe.menu;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.presentation.hilfe.OnlineHilfeVerfuegbar;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

/**
 *  on 19.08.2015.
 */
public class OnlineHilfeMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient OnlineHilfeVerfuegbar onlineHilfeVerfuegbar;

  @Override
  protected boolean isDisabledInternal() {
    return !onlineHilfeVerfuegbar.isOnlineHilfeVerfuegbar();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return AbstractMenuItemEntry.KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ONLINE_HILFE_ANZEIGEN);
  }

  @Override
  public String getLabelKey() {
    return "online.hilfe.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconQuestion();
  }

  @Override
  protected boolean isShowBlockUi() {
    return false; // wird in neuem Browserfenster geöffnet, daher kein BlockUi
  }

  @Override
  public String getTargetViewId() {
    return FacesContextUtil.getContextPath() + "/help" + onlineHilfeVerfuegbar.getOnlineHilfePath() + "/" + onlineHilfeVerfuegbar.getIndexFile();
  }

  @Override
  protected String buildUrlForTargetViewId(String viewID) {
    return viewID;
  }

  @Nullable
  @Override
  public String getTarget() {
    return TARGET_EXTERN;
  }

}
